*** COS 2018 12, last update 2023 01  
           
program define dq_des_sp1  
syntax [if] [in], [ indent(int 0)]  
marksample touse, novarlist  
local indent=`indent'  
local adoname "dq_des_sp1"  
local text_i "di as text _n "  					  
local l0 "original"  
local l1 "modified"  
*** Loop over variables of result scalar file to create descriptive statistics  
capture drop *_000*			  
qui ds *_* , has(type numeric)  
local numvarlist "`r(varlist)'"  
foreach var of varlist `numvarlist' {  
	local varuse=1					  
	local strexclude "initalobsnum _lim_ dataset variable modified pointer"				  
	foreach str in `strexclude' {  
		if strpos("`var'","`str'")>0  {  
			local varuse=0	  
		}        
	}         
	if `varuse'==1 {  
		qui ds `var'															  
		local scalar_vnames "`r(varlist)'"										  
		local vlabel : var label `var'											  
		* Write properties into summary scalars  
		forvalues level=0/1 { 													  
			        
			qui levelsof variable_rolenumber									  
			numlist "0 `r(levels)'"												  
			        
			foreach vtype of numlist  `r(numlist)' {							  
				local vt  "vt_`vtype'"											  
				if `vtype'==0 	qui sum `var' if modified==`level'     								, det		  
				if `vtype'>0	qui sum `var' if modified==`level' & variable_rolenumber==`vtype'	, det		  
				if r(N)>0 {														  
					if strpos("`scalar_vnames'","_dqi")==0  {							  
						scalar sU_`var'_V`vtype'ME`level' = r(mean)  
						global sU_`var'_V`vtype'ME`level' "MEAN `vlabel' $`vt' `l`level''"		  
						scalar sU_`var'_V`vtype'MD`level' = r(p50)  
						global sU_`var'_V`vtype'MD`level' "MEDIAN `vlabel' $`vt' `l`level''"		  
						scalar sU_`var'_V`vtype'MI`level' = r(min)  
						global sU_`var'_V`vtype'MI`level' "MIN `vlabel' $`vt' `l`level''"  
						scalar sU_`var'_V`vtype'MA`level' = r(max)  
						global sU_`var'_V`vtype'MA`level' "MAX `vlabel' $`vt' `l`level''"  
					}     
					if strpos("`scalar_vnames'","_dqi")>0  {  
						capture global sU_`var'_Q0V`vtype'N`level' "Summary `vlabel' $`vt' N `l`level''"						  
						capture scalar sU_`var'_Q0V`vtype'N`level' = r(N)  
						qui levelsof `var'  
						foreach ql of numlist  `r(levels)' {		  
							if `vtype'==0 	qui tab `var' if `var'==`ql' 							   	  
								else 		qui tab `var' if `var'==`ql' & variable_rolenumber==`vtype'		  
							    
							scalar sU_`var'_Q`ql'V`vtype'N`level' = r(N)  
							global sU_`var'_Q`ql'V`vtype'N`level' "N `vlabel' $`vt' `l`level''"	  
							scalar sU_`var'_Q`ql'V`vtype'P`level' = `=sU_`var'_Q`ql'V`vtype'N`level''	/ `=sU_`var'_Q0V`vtype'N`level'' * 100  
							global sU_`var'_Q`ql'V`vtype'P`level' "% `vlabel' $`vt' `l`level''"	  
						}    
					}     
				}      
				       
			}       
					      
		}        
		         
	}         
	          
} 	        
	          
end        
