*** COS 2018 11, last update 2023 02  
           
program define dq_dm_dat , rclass  
syntax varlist [if] [in], $syntax_variablelists $syntax_debugging  
marksample touse, novarlist  
local indent=`indent'+5  
local adoname "dq_dm_dat"  
local text_i "di as text _n "  					  
local convertsuccess=0								  
local var_format `: format `varlist''  
if strpos("`var_format'","%t")>0 {  
	if strpos("`var_format'","tc")>0 {  
		tempvar dv  
		gen `dv'=dofc(`varlist')  
		replace `varlist'=`dv'  
		drop `dv'  
	}         
	format  `varlist' $dateformat	  
	local convertsuccess = 1  
}	         
if strpos("`var_format'","%t")==0 {  
	capture confirm numeric variable `varlist'											  
	if _rc==0 	{  
		tempvar sumvar  
		qui egen `sumvar'=total(`varlist')  
		qui sum `sumvar'  
		if (`r(max)'-trunc(`r(max)'))<.00001 { 											  
			qui sum `varlist', det  
			if r(max)>10000 {			  
				if r(max)>300000  qui replace `varlist'=dofc(`varlist')					  
				if r(max)<30000   qui replace `varlist'=dofc(`varlist'*1000*60*60*24)		  
			format  `varlist' $dateformat  
				       
			*** DQ_action_decision: 	DQ_INT_18  
			dq_out_add,  tablename(integtable_studydata) row(integtablerows_studydata) columns(3) ///  
							colcontent1("$Action_1") colcontent2("$Studyvariable_1: `varlist'") colcontent3($DQ_INT_action_18) vartype(`vartype')  indent(`indent') 	  
			local convertsuccess=1		  
			}       
		}        
	}	        
}	         
*** If no scalar for lower hard limit , implement one to remove negative time values  
if `convertsuccess'==1 {  
	capture confirm scalar lim_hl_$$`varlist'  
	if  _rc>0 {  
		scalar lim_hl_$$`varlist'=0  
	}         
}          
if strpos("`var_format'","%t")==0 {  
	capture confirm string variable `varlist'										  
	if _rc==0 	{  
		local dateformats = "YMD YDM DMY MDY YMDhms YDMhms YMDhm YDMhm"				  
		tokenize "`dateformats'"  
		tempvar datevarref		  
		tempvar datevarnew		  
		local N_ref=0			  
		local N_new=0			  
		while "`1'"~="" {  
			capture drop `datevarnew'  
			qui gen `datevarnew'=date(`varlist', "`1'")  
			if `datevarnew'<0 replace `datevarnew'=. 								  
			qui count if `datevarnew'<.  
			local N_new= r(N)  
			if `N_new'>`N_ref'   {													  
				capture drop `datevarref'  
				gen `datevarref'= `datevarnew'  
				local N_ref=`N_new'  
				local convertsuccess=1  
			} 	     
			macro shift		  
		}	       
		if `convertsuccess'==1 {  
			local varlabel : var label `varlist'	  
			drop `varlist'					  
			qui gen  	`varlist'= `datevarref'  
			lab var 	`varlist' `varlabel'  
			format  	`varlist' $dateformat  
			        
			*** DQ_action_decision: 	DQ_INT_8  
			dq_out_add,  tablename(integtable_studydata) row(integtablerows_studydata) columns(3) colcontent1("$Action_1") colcontent2("$Studyvariable_1: `varlist'") colcontent3($DQ_INT_action_8 `N_ref') vartype(`vartype')  indent(`indent') 						  
		}        
	}	        
}	         
if `convertsuccess'==1 {  
	qui levelsof `varlist' if `touse'  
	if wordcount("`r(levels)'")<10 {  
		dq_out_add ,  tablename(integtable_studydata) row(integtablerows_studydata) columns(3) colcontent1($Note_1) colcontent2($vt_5: `varlist') ///  
										colcontent3("$littlevariation_issue_2 Datetimevariable `r(levels)' levels") vartype(time)  indent(`indent')			  
	}         
}          
return local convertsuccess=`convertsuccess'  
end        
* https://phantran.net/converting-between-numeric-and-string-formats-in-stata/  WATCH  
